﻿using System;

namespace FatopTheWorld {
	public enum BGM : byte{
		Nothing = 0,
		Stage01,
		Stage02,
		Stage03,
		Stage04,
		Stage05,
		Stage06,
		Stage07,
		Stage08,
		Stage09,
		Stage10,
		Stage11,
		Option,
		Ending,
		Gallery,
		StoryNormal,
		StoryLast,
		StorySecret,
		StoryInif,
		VSMenu,
		Title,
	}
	class Audio {
		public static readonly string[] BGMPath;
		public const string BGMDir = @"BGM\";
		static Audio(){
			BGMPath = MakeData(BGMDir, ".faf"
				,null
				,"01_burnat"
				,"02_fluip"
				,"03_scappion"
				,"04_smow"
				,"05_hydead"
				,"06_remilsteid"
				,"07_shadows"
				,"08_remilsteid(rage)"
				,"09_secret_1"
				,"10_secret_2"
				,"11_inif"
				,"option"
				,"ending"
				,"gallery"
				,"story_normal_phase"
				,"story_last_phase"
				,"story_secret_phase"
				,"story_inif_phase"
				,"vs"
				,"title"
			);
		}
		internal static string[] MakeData(string dir, string extension, params string[] data){
			string[] returnValue = new string[data.Length];
			for(int i = data.Length - 1; i >= 0 ; i--){
				returnValue[i] = dir + data[i] + extension;
			}
			return(returnValue);
		}
		public static string GetPath(BGM bgm){
			return(BGMPath[(byte)bgm]);
		}
	}
}
