﻿using FukuracamDX;
using System.Collections.Generic;

namespace FatopTheWorld
{
	/// <summary>
	/// ID_[種別][%04d]
	/// 種別＝B		Battle
	/// </summary>
	class Error
	{
		/// <summary></summary>
		private string Header;
		/// <summary></summary>
		private int Id;
		/// <summary></summary>
		private string Message;
		/// <summary></summary>
		private static string KIND_COMMON = "COMMON ERROR(CODE:{0:D5}): ";
		/// <summary></summary>
		private static string KIND_PROGRAM = "PROGRAM ERROR(CODE:{0:D5}): ";
		/// <summary>Wrong switch on MagicKind at CPUBrain.CalcCPUScore().</summary>
		public static Error ID_00001 = new Error(KIND_PROGRAM, 00001, "Wrong switch on MagicKind at CPUBrain.CalcCPUScore().");
		/// <summary>Wrong switch on MagicKind at Battle.Calc().</summary>
		public static Error ID_00002 = new Error(KIND_PROGRAM, 00002, "Wrong switch on MagicKind at Battle.Calc().");
		/// <summary>Cannot read a memory file.</summary>
		public static Error ID_00003 = new Error(KIND_COMMON,  00003, "Cannot read a memory file.");
		/// <summary>Command [pm]'s number of parameters is incorrect.</summary>
		public static Error ID_00004 = new Error(KIND_COMMON,  00004, "Command [pm]'s number of parameters is incorrect.");
		/// <summary>Wrong switch on JewelKind at Player.ClearField().</summary>
		public static Error ID_00005 = new Error(KIND_PROGRAM, 00005, "Wrong switch on JewelKind at Player.ClearField().");
		/// <summary>Cannot delete obstracle jewels by magic jewels.</summary>
		public static Error ID_00006 = new Error(KIND_PROGRAM, 00006, "Cannot delete obstracle jewels by magic jewels.");
		/// <summary>Cannot delete hard obstracle jewels by magic jewels.</summary>
		public static Error ID_00007 = new Error(KIND_PROGRAM, 00007, "Cannot delete hard obstracle jewels by magic jewels.");
		/// <summary>The command "{0}" is nothing.</summary>
		public static Error ID_00008 = new Error(KIND_COMMON,  00008, "The command \"{0}\" is nothing.");
		/// <summary>An error below occurred at a story file "{0}".\n{1}</summary>
		public static Error ID_00009 = new Error(KIND_COMMON,  00009, "An error below occurred at a story file \"{0}\"." + FCAMSystem.NewLine + "{1}");
		/// <summary>Not found a story file "{0}".</summary>
		public static Error ID_00010 = new Error(KIND_COMMON,  00010, "Not found a story file \"{0}\" at Story.Load().");
		/// <summary>Not found a story file "{0}".</summary>
		public static Error ID_00011 = new Error(KIND_COMMON,  00011, "Not found a story file \"{0}\" at Story.Calc().");
		/// <summary>
		/// 
		/// </summary>
		private Error(string kind, int id, string message)
		{
			Header = FCAMStrings.Format(kind, id);
			Id = id;
			Message = message;
		}
		/// <summary>
		/// 
		/// </summary>
		private static void Throw(Error id, params object[] args)
		{
			FCAMSystem.Throw(new FCAMException(id.Header + FCAMStrings.Format(id.Message, args)));
		}
		/// <summary>
		/// 
		/// </summary>
		public void Throw(params object[] args)
		{
			Throw(this, args);
		}
	}
}
