﻿using System.Collections.Generic;
using FukuracamDX;

namespace FatopTheWorld{
	class Memory: FCAMFileLiterable{
		///	
		/// 
#if TRIAL
		private static readonly string[] DIFFICULT_NAME = new string[]{"BEGINNER", "NORMAL"};
#else
		private static readonly string[] DIFFICULT_NAME = new string[]{"BEGINNER", "NORMAL", "HARD", "MADNESS!"};
#endif
		public static readonly int NumberDifficults = DIFFICULT_NAME.Length;
		public static readonly sbyte MAX_DIFFICULT = (sbyte)(NumberDifficults - 1);
		//	難易度選択に条件が必要となる境界
		public const int DIFFICULT_CONDITION_BORDER = 2;
		public const int DIFFICULT_CONDITION_CLEARED_STAGES = 9;
		private const int VERSION = 3;
		public const string FILEPATH_MEMORY = "memory.dat";
		public const sbyte MAX_SEVOLUME = 10;
		public const sbyte MAX_BGMVOLUME = 10;
		///	
		/// 
		private sbyte __Difficult;
		public sbyte Difficult{
			get{
				return(__Difficult);
			}
			set{
				Common.Stage = 0;
				__Difficult = value;
			}
		}
		public sbyte SEVolume, BGMVolume;
		public sbyte[] ClearedStagesArray;
		public sbyte ClearedStages{get{return(ClearedStagesArray[Difficult]);} set{ClearedStagesArray[Difficult] = value;}}
		public sbyte ClearedCharacters{
			get{
				return(GetClearedCharactersAtStage(ClearedStages + Common.STAGE_SHIFT[Difficult]));
			}
		}
		public sbyte CharaShift{get{return(Common.CHARA_SHIFT[Difficult]);}}
		///	<summary></summary>
		/// 
		public Memory(){
			__Difficult = 0;
			ClearedStagesArray = new sbyte[DIFFICULT_NAME.Length];
			SEVolume = 8;
			BGMVolume = 8;
		}
		public static sbyte GetClearedCharactersAtStage(int stage){
			return(Common.CLEARED_CHARACTERS_AT_STAGE[Game.MemoryData.Difficult, stage]);
		}
		/// <summary></summary>
		///	
		public override long Literaten(FCAMFileLiterater literater){
			long sum = 0;
			int version = VERSION;
			try{
				sum += literater.Literaten(ref version);
				switch(version){
					case 3:{
						goto case 2;
					}
					case 2:{
						sum += literater.Literaten(ref Common.KeyLeft);
						sum += literater.Literaten(ref Common.KeyUp);
						sum += literater.Literaten(ref Common.KeyRight);
						sum += literater.Literaten(ref Common.KeyDown);
						sum += literater.Literaten(ref Common.KeyA);
						sum += literater.Literaten(ref Common.KeyB);
						sum += literater.Literaten(ref Common.KeyL);
						sum += literater.Literaten(ref Common.KeyR);
						sum += literater.Literaten(ref Common.KeyLeft2);
						sum += literater.Literaten(ref Common.KeyUp2);
						sum += literater.Literaten(ref Common.KeyRight2);
						sum += literater.Literaten(ref Common.KeyDown2);
						sum += literater.Literaten(ref Common.KeyA2);
						sum += literater.Literaten(ref Common.KeyL2);
						sum += literater.Literaten(ref Common.KeyR2);
						goto case 1;
					}
					case 1:{
						sum += literater.Literaten(ref __Difficult);
						sum += literater.Literaten(ref SEVolume);
						sum += literater.Literaten(ref BGMVolume);
						//	version 3 より、ループ回数は配列長からデータに依存へ
						//for(int i = 0; i < ClearedStagesArray.Length; i++){
						int length = ClearedStagesArray.Length;
						sum += literater.Literaten(ref length);
						for(int i = 0; i < length; i++){
							sum += literater.Literaten(ref ClearedStagesArray[i]);
						}
						break;
					}
					default:{
						Error.ID_00003.Throw();
						break;
					}
				}
			}catch{}
			return(sum);
		}
		/// <summary></summary>
		///	
		public string GetDifficultName(){
			return(DIFFICULT_NAME[Difficult]);
		}
	}
}
