﻿using FukuracamDX;
using System.Collections.Generic;

namespace FatopTheWorld.Scenes{
	class ChooseLanguage: FCAMScene{
		private readonly string HELP_MESSAGE = "Push F1 to Reset Key Settings.";
		private readonly string HELP_MESSAGE_AFTER = "Key Settings Resetted!";
		private const string SE_DECIDE_PATH = @"SE\decide.wav";
		private const int FRAME_MENU = 1;
		private readonly string[] MENU_ITEMS = {	"Choose Mode",
													"1. NOT contains talking scene in Story Mode" + FCAMSystem.NewLine + "ストーリーモードで会話無し",
													"2. Contains talking scene in Story Mode" + FCAMSystem.NewLine + "(needs the ability to read Japanese)" + FCAMSystem.NewLine + "ストーリーモードで会話有り",
												};
		private int frame;
		private int cursor;
		private bool resetted;
		protected override void Load(FCAMGraphics g, FCAMInput input, FCAMContentsManager manager){
#if DEBUG
			if(FCAMDebug.IsDebug){
				Base.Text = "ChooseLanguage";
			}
#endif
			frame = 0;
			cursor = 1;
			resetted = false;
		}
		protected override void Calc(FCAMInput input, FCAMContentsManager manager){
#if DEBUG
			if(FCAMDebug.IsDebug){
				if(Common.KeyDebug1)
					frame = FRAME_MENU;
			}
#endif
			if(frame < FRAME_MENU){
				frame++;
			}else{
				if(input.Keyboard[FCAMKey.F1] && !resetted){
					Common.InitializeKeySettings(input);
					resetted = true;
				}
				Common.ReadyPlayCueSelect(cursor);
				if(Common.KeyUp){
					cursor = FCAMMath.Max(1, cursor - 1);
				}
				if(Common.KeyDown){
					cursor = FCAMMath.Min(MENU_ITEMS.Length - 1, cursor + 1);
				}
				Common.PlayCueSelect(cursor);
				if(Common.KeyA){
					Common.PlaySE(SE_DECIDE_PATH);
					Game.Instance.Language = cursor == 1 ? Languages.NonJpn : Languages.Jpn;
					PopScene();
				}
			}
		}
		protected override void Draw(FCAMGraphics g){
			g.Clear(FCAMColor.Black);
			if(frame >= FRAME_MENU){
				for(int i = 0; i < MENU_ITEMS.Length; i++){
					int y = i * 64 + 120;
					FCAMColor color = i == 0 || i == cursor ? FCAMColor.White : FCAMColor.Gray;
					g.DrawString(FCAMDrawStringFormat.Center, color, 0, y, MENU_ITEMS[i]);
				}
			}
			Common.DrawHelp(resetted ? HELP_MESSAGE_AFTER : HELP_MESSAGE);
		}
	}
}
