﻿using System.Collections.Generic;
using FukuracamDX;

namespace FatopTheWorld.Scenes{
	class Ending: Telop.TelopBase{
		protected override void Load(FCAMGraphics g, FCAMInput input, FCAMContentsManager manager){
			TelopFileNameFormat = Game.Instance.Language == Languages.NonJpn ? @"Ending\NonJpn\ending{0:D2}.txt" : @"Ending\ending{0:D2}.txt";
			base.Load(g, input, manager);
			Common.ChangeBGM(BGM.Ending);
		}
	}
	/*
	class Ending: FCAMScene{
		const string FILENAMEFORMAT_TELOP = @"Ending\ending{0:D2}.txt";
		const string HELP_MESSAGE_FORMAT = "A Key: Next Telop   B Key: To {0}";
		const int FRAME_FADEOUT = 100;
		const int FRAME_NEXTTELOP = 200;
		const int TELOPNUMBER_NEXTSCENE = 6;
		int frame, telopFileNumber, telopFrame;
		string telopData;
		List<string> telopLines;
		void NextTelop(FCAMContentsManager manager){
			telopFileNumber++;
			telopData = manager.MakeString(FCAMStrings.Format(FILENAMEFORMAT_TELOP, telopFileNumber));
			telopLines.Clear();
			foreach(string value in FCAMStrings.SplitLine(telopData))
				telopLines.Add(value);
			telopFrame = 0;
		}
		protected override void Load(FCAMGraphics g, FCAMInput input, FCAMContentsManager manager){
#if DEBUG
			if(FCAMDebug.IsDebug){
				Base.Text = "Ending";
			}
#endif
			telopLines = new List<string>();
			frame = telopFileNumber = 0;
			NextTelop(manager);
			Common.ChangeBGM(BGM.Ending);
		}
		protected override void Unload(){
		}
		protected override void Calc(FCAMInput input, FCAMContentsManager manager){
#if DEBUG
			if(FCAMDebug.IsDebug){
				if(Common.KeyDebug2){
					telopFrame = FRAME_NEXTTELOP;
					telopFileNumber = TELOPNUMBER_NEXTSCENE;
				}
			}
#endif
			frame++;
			telopFrame++;
			if(Common.CommonKeyA()){
				telopFrame = FRAME_NEXTTELOP;
				telopFileNumber = TELOPNUMBER_NEXTSCENE;
			}
			if(telopFrame > FRAME_NEXTTELOP){
				if(telopFileNumber < TELOPNUMBER_NEXTSCENE)
					NextTelop(manager);
				else{
					PopScene();
				}
			}
		}
		protected override void Draw(FCAMGraphics g){
			FCAMRectangle rectangle = g.Font.Measure(telopData);
			int baseY;
			g.FillGradatedRectangle(0, 0, g.Width, g.Height, FCAMColor.HalfDarkRed, FCAMColor.HalfDarkBlue, FCAMColor.HalfDarkGreen, FCAMColor.HalfYellow);
			rectangle.VerticalCenterInto(g.Height);
			baseY = rectangle.Y;
			for(int i = 0; i < telopLines.Count; i++){
				string sz = telopLines[i];
				int y;
				rectangle = g.Font.Measure(sz);
				rectangle.HorizontalCenterInto(g.Width);
				switch(telopFileNumber){
					//case 1:
					default:
						y = baseY + i * g.Font.Height;
						if(telopFrame < FRAME_NEXTTELOP / 2)
							rectangle.Offset(0, FCAMMath.Min(telopFrame * 8 - g.Font.Height, y));
						else
							rectangle.Offset(0, FCAMMath.Max((telopFrame - FRAME_NEXTTELOP / 2) * 8 + baseY, y));
						g.DrawString(rectangle, sz);
						break;
					//case 2:
					//    rectangle.Offset(0, baseY);
					//    g.DrawString(
					//        new FCAMColor(
					//            telopFrame < FRAME_FADEOUT ?
					//            FCAMMath.Min(telopFrame * 8, FCAMColor.MaxValue) :
					//            FCAMMath.Max(FCAMColor.MaxValue - (telopFrame - FRAME_FADEOUT) * 8, FCAMColor.MinValue),
					//            FCAMColor.MaxValue
					//        ),
					//        rectangle,
					//        sz
					//    );
					//    break;
				}
			}
		}
	}
	*/
}
