﻿using FukuracamDX;
using System.Collections.Generic;

namespace FatopTheWorld.Scenes{
	class Gallery: FCAMScene{
		const int FRAME_MENU = 1;
		readonly string HELP_MESSAGE = "Lt/Rt Button: Change Character" + FCAMSystem.NewLine
									 + "A Button: Change State   B Button: to Title   C Button: Hide Text";
		int frame = 0;
		int selectedChara = 0;
		FCAMTexture[] charaTextures = new FCAMTexture[]{null, null};
		bool fat = false;
		bool showText;
		protected override void Load(FCAMGraphics g, FCAMInput input, FCAMContentsManager manager){
#if DEBUG
			if(FCAMDebug.IsDebug){
				Base.Text = "Gallery";
			}
#endif
			Common.ChangeBGM(BGM.Gallery);
			Refresh(manager);
			showText = true;
		}
		protected override void Unload(){
			for(int i = charaTextures.Length - 1; i >= 0; i--){
				FCAMSystem.DisposeClass(out charaTextures[i]);
			}
		}
		protected override void Calc(FCAMInput input, FCAMContentsManager manager){
#if DEBUG
			if(FCAMDebug.IsDebug){
				if(Common.KeyDebug1)
					frame = FRAME_MENU;
			}
#endif
			if(frame < FRAME_MENU){
				frame++;
			}else{
				Common.ReadyPlayCueSelect(selectedChara);
				if(Common.KeyLeft && selectedChara > 0){
					selectedChara--;
					Refresh(manager);
				}
				if(Common.KeyRight && selectedChara < Game.MemoryData.ClearedCharacters){
					selectedChara++;
					Refresh(manager);
				}
				Common.PlayCueSelect(selectedChara);
				if(Common.KeyA){
					Common.CueDecide.Play();
					fat ^= true;
				}
				if(Common.KeyB){
					Common.CueCancel.Play();
					PopScene();
				}
				if(Common.KeyR){
					showText ^= true;
				}
			}
		}
		protected override void Draw(FCAMGraphics g){
			g.Clear();
			if(frame >= FRAME_MENU){
				int index = fat ? 1 : 0;
				g.DrawTexture(charaTextures[index], (g.Width - charaTextures[index].Width) / 2, (g.Height - charaTextures[index].Height) / 2);
				if(showText){
					g.DrawString(FCAMDrawStringFormat.Hemming,
								 0,
								 320,
								 "Chara:" + FCAMSystem.NewLine +
								 selectedChara + FCAMSystem.NewLine +
								 (selectedChara == 0 ? "" : 
									"Fat:" + FCAMSystem.NewLine +
									fat
								 )
								);
				}
			}
			if(showText){
				Common.DrawHelp(HELP_MESSAGE);
			}
		}
		private void Refresh(FCAMContentsManager manager){
			FCAMSystem.DisposeClass(out charaTextures[0]);
			FCAMSystem.DisposeClass(out charaTextures[1]);
			charaTextures[0] = manager.MakeTexture(selectedChara == 0 ? Title.FILENAME_TITLE : Common.GetCharacterPath(selectedChara, 0));
			charaTextures[1] = manager.MakeTexture(selectedChara == 0 ? Title.FILENAME_TITLE : Common.GetCharacterPath(selectedChara, 1));
		}
	}
}
