﻿using FukuracamDX;
using System.Collections.Generic;

namespace FatopTheWorld.Scenes{
	class KeySetting: FCAMScene{
		const int FRAME_MENU = 1;
		List<string> menus;
		FCAMInputState[] menuValues;
		int frame, cursor, editKey;
		FCAMRectangle menuWindowRectangle;
		public KeySetting(): base(false, FCAMDrawInheritance.Whole){}
		protected override void Load(FCAMGraphics g, FCAMInput input, FCAMContentsManager manager){
#if DEBUG
			if(FCAMDebug.IsDebug){
				Base.Text = "KeySetting";
			}
#endif
			menus = new List<string>(new string[]{
				"[1P]Left     {0, 16}",
				"[1P]Up       {0, 16}",
				"[1P]Right    {0, 16}",
				"[1P]Down     {0, 16}",
				"[1P]A-Button {0, 16}",
				"[1P]B-Button {0, 16}",
#if ATTACK_MAGIC
				"[1P]L-Button {0, 16}",
				"[1P]R-Button {0, 16}",
#else
				"[1P]C-Button {0, 16}",
#endif
				"[2P]Left     {0, 16}",
				"[2P]Up       {0, 16}",
				"[2P]Right    {0, 16}",
				"[2P]Down     {0, 16}",
				"[2P]A-Button {0, 16}",
				"[2P]B-Button {0, 16}",
#if ATTACK_MAGIC
				"[2P]L-Button {0, 16}",
				"[2P]R-Button {0, 16}",
#else
				"[2P]C-Button {0, 16}",
#endif
				"Back{0}"});
#if ATTACK_MAGIC
			menuWindowRectangle.SetLTRB(40, 120, 600, 400);
#else
			menuWindowRectangle.SetLTRB(40, 140, 600, 380);
#endif
			frame = cursor = 0;
			editKey = -1;
		}
		protected override void Calc(FCAMInput input, FCAMContentsManager manager){
#if DEBUG
			if(FCAMDebug.IsDebug){
				if(Common.KeyDebug1){
					frame = FRAME_MENU;
				}
			}
#endif
			menuValues = new FCAMInputState[]{
				Common.KeyLeft,
				Common.KeyUp,
				Common.KeyRight,
				Common.KeyDown,
				Common.KeyA,
				Common.KeyB,
#if ATTACK_MAGIC
				Common.KeyL,
				Common.KeyR,
#else
				Common.KeyR,
#endif
				Common.KeyLeft2,
				Common.KeyUp2,
				Common.KeyRight2,
				Common.KeyDown2,
				Common.KeyA2,
				Common.KeyB2,
#if ATTACK_MAGIC
				Common.KeyL2,
				Common.KeyR2,
#else
				Common.KeyR2,
#endif
			};
			if(frame < FRAME_MENU){
				frame++;
				return;
			}
			if(editKey == -1){
				int halfNumberMenuValues = menuValues.Length / 2;
				Common.ReadyPlayCueSelect(cursor);
				if(Common.CommonKeyUp()){
					cursor--;
				}
				if(Common.CommonKeyDown()){
					cursor++;
				}
				if(cursor != menuValues.Length){
					if(Common.CommonKeyLeft()){
						if(cursor >= halfNumberMenuValues && cursor < menuValues.Length){
							cursor -= halfNumberMenuValues;
						}else{
							cursor += halfNumberMenuValues;
						}
					}
					if(Common.CommonKeyRight()){
						if(cursor >= 0 && cursor < halfNumberMenuValues){
							cursor += halfNumberMenuValues;
						}else{
							cursor -= halfNumberMenuValues;
						}
					}
				}
				if(Common.CommonKeyB()){
					Common.CueCancel.Play();
					cursor = menus.Count - 1;
				}
				cursor = FCAMMath.Mod(cursor, menus.Count);
				Common.PlayCueSelect(cursor);
				if(cursor == menus.Count - 1){
					if(Common.CommonKeyA()){
						Common.CueDecide.Play();
						PopScene();
					}
				}else if(Common.CommonKeyA()){
					Common.CueDecide.Play();
					editKey = cursor;
				}
			}else{
				FCAMInputState state;
				state = input.GetInputStateClassFromName(input.GetInputName(false));
				if(state != FCAMInputState.Empty){
					switch(editKey){
#if ATTACK_MAGIC
						case 0:{Common.KeyLeft = state; break;}
						case 1:{Common.KeyUp = state; break;}
						case 2:{Common.KeyRight = state; break;}
						case 3:{Common.KeyDown = state; break;}
						case 4:{Common.KeyA = state; break;}
						case 5:{Common.KeyB = state; break;}
						case 6:{Common.KeyL = state; break;}
						case 7:{Common.KeyR = state; break;}
						case 8:{Common.KeyLeft2 = state; break;}
						case 9:{Common.KeyUp2 = state; break;}
						case 10:{Common.KeyRight2 = state; break;}
						case 11:{Common.KeyDown2 = state; break;}
						case 12:{Common.KeyA2 = state; break;}
						case 13:{Common.KeyB2 = state; break;}
						case 14:{Common.KeyL2 = state; break;}
						case 15:{Common.KeyR2 = state; break;}
#else
						case 0:{Common.KeyLeft = state; break;}
						case 1:{Common.KeyUp = state; break;}
						case 2:{Common.KeyRight = state; break;}
						case 3:{Common.KeyDown = state; break;}
						case 4:{Common.KeyA = state; break;}
						case 5:{Common.KeyB = state; break;}
						case 6:{Common.KeyR = state; break;}
						case 7:{Common.KeyLeft2 = state; break;}
						case 8:{Common.KeyUp2 = state; break;}
						case 9:{Common.KeyRight2 = state; break;}
						case 10:{Common.KeyDown2 = state; break;}
						case 11:{Common.KeyA2 = state; break;}
						case 12:{Common.KeyB2 = state; break;}
						case 13:{Common.KeyR2 = state; break;}
#endif
					}
					editKey = -1;
				}
			}
		}
		protected override void Draw(FCAMGraphics g){
			g.Font = Common.FontCommon;
			g.FillRectangle(new FCAMColor(FCAMColor.HalfValue, FCAMColor.MinValue));
			if(frame >= FRAME_MENU){
				int halfNumberMenuValues = menuValues.Length / 2;
				Common.DrawWindow(menuWindowRectangle);
				for(int i = 0; i < menus.Count; i++){
					string sz;
					FCAMRectangle rectangle;
					string name = i < menuValues.Length ? menuValues[i].Name : "";
					if(editKey != -1){
						if(editKey != i)
							continue;
						name = "?????";
					}
					sz = FCAMStrings.Format(cursor == i ? ">>" + menus[i] + "<<" : menus[i], name);
					rectangle = g.Font.Measure(sz);
					int column = i / halfNumberMenuValues;
					int row = i % halfNumberMenuValues;
					if(column < 2){
						rectangle.X = column * 280 + menuWindowRectangle.X + Common.WindowBorderWeight;
						rectangle.Y = row * 32 + menuWindowRectangle.Y + Common.WindowBorderWeight;
					}else{
						rectangle.HorizontalCenterInto(g.Width);
						rectangle.Offset(0, halfNumberMenuValues * 32 + menuWindowRectangle.Y + Common.WindowBorderWeight);
					}
					g.DrawString(g.Font.Color.InvertRGB(), rectangle, sz);
					rectangle.Offset(-1, -1);
					g.DrawString(rectangle, sz);
				}
			}
		}
	}
}
