﻿using FukuracamDX;
using System.Collections.Generic;

namespace FatopTheWorld.Scenes{
	class Logo: FCAMScene{
		const string LOGONAME = "Fukuracam Presents...";
		const int FRAME_FADEOUT = 50;
		const int FRAME_NEXTSCENE = 150;
		int frame = 0;
		protected override void Load(FCAMGraphics g, FCAMInput input, FCAMContentsManager manager){
#if DEBUG
			if(FCAMDebug.IsDebug){
				Base.Text = "Logo";
			}
#endif
			Common.ChangeBGM(BGM.Nothing);
		}
		protected override void Calc(FCAMInput input, FCAMContentsManager manager){
#if DEBUG
			if(FCAMDebug.IsDebug){
				if(Common.KeyDebug2){
					frame = FRAME_NEXTSCENE;
				}
			}
#endif
			frame++;
			if(frame > FRAME_NEXTSCENE){
				ExchangeScene<Scenes.Opening>();
			}
		}
		protected override void Draw(FCAMGraphics g){
			FCAMColor color = new FCAMColor(frame < FRAME_FADEOUT ? FCAMMath.Min(frame * 8, FCAMColor.MaxValue) : FCAMMath.Within(FCAMColor.MinValue, FCAMColor.MaxValue - (frame - FRAME_FADEOUT) * 8, FCAMColor.MaxValue), FCAMColor.MaxValue);
			FCAMRectangle rectangle = g.Font.Measure(LOGONAME);
			g.FillGradatedRectangle(0, 0, g.Width, g.Height, FCAMColor.Red, FCAMColor.Blue, FCAMColor.Green, FCAMColor.Gray);
			rectangle.CenterInto(g.Width, g.Height);
			g.DrawString(color, rectangle, LOGONAME);
		}
	}
}
