﻿using System.Collections.Generic;
using FukuracamDX;

namespace FatopTheWorld.Scenes{
	class Opening: Telop.TelopBase{
		protected override void Load(FCAMGraphics g, FCAMInput input, FCAMContentsManager manager){
			TelopFileNameFormat = Game.Instance.Language == Languages.Jpn ? @"Opening\opening{0:D2}.txt" : "";
			base.Load(g, input, manager);
		}
	}
	/*
	class Opening: FCAMScene{
		const string LOGONAME = "Fukuracam Presents...";
		const string FILENAMEFORMAT_TELOP = @"Opening\opening{0:D2}.txt";
		const string HELP_MESSAGE_FORMAT = "A Key: Next Telop   B Key: To {0}";
		const int FRAMES_BASE = 300;
		const int NEXTTELOP_FADE = -128;
		//	const int FRAME_NEXTTELOP = 300;
		int FRAME_NEXTTELOP;
		//	const int FRAME_FADEOUT = FRAME_NEXTTELOP / 2; //	150;
		int FRAME_FADEOUT;
		const int FRAMES_PER_LINE = 50;
		const int TELOP_MOVE_SPEED = 8;
		const int TELOP_FADE_SPEED = 8;
		//	const int TELOPNUMBER_NEXTSCENE = 2;
		int TELOPNUMBER_NEXTSCENE;
		int frame, telopFileNumber, telopFrame;
		int alpha;
		string telopData;
		List<string> telopLines;
		void NextTelop(FCAMContentsManager manager){
			telopFileNumber++;
			telopData = manager.MakeString(FCAMStrings.Format(FILENAMEFORMAT_TELOP, telopFileNumber));
			telopLines.Clear();
			foreach(string value in FCAMStrings.SplitLine(telopData)){
				telopLines.Add(value);
			}
			telopFrame = 0;
			FRAME_NEXTTELOP = FRAMES_BASE + telopLines.Count * FRAMES_PER_LINE;
			FRAME_FADEOUT = FRAME_NEXTTELOP / 2;
		}
		protected override void Load(FCAMGraphics g, FCAMInput input, FCAMContentsManager manager){
#if DEBUG
			if(FCAMDebug.IsDebug){
				Base.Text = "Opening";
			}
#endif
			Common.ChangeBGM(BGM.Nothing);
			telopLines = new List<string>();
			frame = telopFileNumber = 0;
			for(TELOPNUMBER_NEXTSCENE = 1; TELOPNUMBER_NEXTSCENE < 100; TELOPNUMBER_NEXTSCENE++){
				if(!manager.Exist(FCAMStrings.Format(FILENAMEFORMAT_TELOP, TELOPNUMBER_NEXTSCENE + 1))){
					break;
				}
			}
			NextTelop(manager);
			g.Font = Base.GetDefaultFont();
		}
		protected override void Unload(){
		}
		protected override void Calc(FCAMInput input, FCAMContentsManager manager){
#if DEBUG
			if(FCAMDebug.IsDebug){
				if(Common.KeyDebug2){
					telopFrame = FRAME_NEXTTELOP;
					telopFileNumber = TELOPNUMBER_NEXTSCENE;
				}
			}
#endif
			frame++;
			telopFrame++;
			if(Common.CommonKeyA()){
				telopFrame = FRAME_NEXTTELOP;
			}
			if(Common.CommonKeyB()){
				telopFrame = FRAME_NEXTTELOP;
				telopFileNumber = TELOPNUMBER_NEXTSCENE;
			}
			if(telopFrame > FRAME_NEXTTELOP){
				if(telopFileNumber < TELOPNUMBER_NEXTSCENE){
					NextTelop(manager);
				}else{
					PopScene();
				}
			}
			alpha = telopFrame < FRAME_FADEOUT ? telopFrame * TELOP_FADE_SPEED : FCAMColor.MaxValue - (telopFrame - FRAME_FADEOUT) * TELOP_FADE_SPEED;
			if(alpha < NEXTTELOP_FADE){
				telopFrame = FRAME_NEXTTELOP;
			}
		}
		protected override void Draw(FCAMGraphics g){
			FCAMRectangle rectangle = g.Font.Measure(telopData);
			int baseY;
			//g.FillGradatedRectangle(0, 0, g.Width, g.Height, FCAMColor.Red, FCAMColor.Blue, FCAMColor.Green, FCAMColor.Gray);
			g.FillRectangle(0, 0, g.Width, g.Height, FCAMColor.Black);
			rectangle.VerticalCenterInto(g.Height);
			baseY = rectangle.Y;
			for(int i = 0; i < telopLines.Count; i++){
				string sz = telopLines[i];
				int y;
				rectangle = g.Font.Measure(sz);
				rectangle.HorizontalCenterInto(g.Width);
				y = baseY + i * g.Font.Height;
				if(telopFrame < FRAME_NEXTTELOP / 2){
				    rectangle.Offset(0, FCAMMath.Min(telopFrame * TELOP_MOVE_SPEED - g.Font.Height, y));
				}else{
				    rectangle.Offset(0, FCAMMath.Max((telopFrame - FRAME_NEXTTELOP / 2) * TELOP_MOVE_SPEED + baseY, y));
				}
				g.DrawString(new FCAMColor(FCAMMath.Within(FCAMColor.MinValue, alpha, FCAMColor.MaxValue), FCAMColor.MaxValue),
							 rectangle,
							 sz);
				//switch(telopFileNumber){
				//    case 1:
				//        y = baseY + i * g.Font.Height;
				//        if(telopFrame < FRAME_NEXTTELOP / 2)
				//            rectangle.Offset(0, FCAMMath.Min(telopFrame * TELOP_MOVE_SPEED - g.Font.Height, y));
				//        else
				//            rectangle.Offset(0, FCAMMath.Max((telopFrame - FRAME_NEXTTELOP / 2) * TELOP_MOVE_SPEED + baseY, y));
				//        g.DrawString(rectangle, sz);
				//        break;
				//    case 2:
				//        rectangle.Offset(0, baseY);
				//        g.DrawString(
				//            new FCAMColor(
				//                telopFrame < FRAME_FADEOUT ?
				//                FCAMMath.Min(telopFrame * TELOP_FADE_SPEED, FCAMColor.MaxValue) :
				//                FCAMMath.Max(FCAMColor.MaxValue - (telopFrame - FRAME_FADEOUT) * TELOP_FADE_SPEED, FCAMColor.MinValue),
				//                FCAMColor.MaxValue
				//            ),
				//            rectangle,
				//            sz
				//        );
				//        break;
				//}
			}
			Common.DrawHelp(FCAMStrings.Format(HELP_MESSAGE_FORMAT, PeekScene().Previous is Scenes.Story ? "Story" : "Title" ));
		}
	}
	*/
}
