﻿using FukuracamDX;
using System.Collections.Generic;

namespace FatopTheWorld.Scenes{
	class Option: FCAMScene{
		enum Menu: sbyte{
			Difficult = 0,
#if CHANGE_VOLUME
			SE,
			BGM,
#endif
			KeySetting,
#if RANKING
			Ranking,
#endif
			Back,
		}
		const int FRAME_MENU = 1;
		const string BG_FILEPATH = "option.png";
		List<string> menus, menuValues;
		int frame, cursor;
		FCAMRectangle menuWindowRectangle;
		FCAMTexture textureBG;
		public Option(): base(false, FCAMDrawInheritance.Whole){}
		protected override void Load(FCAMGraphics g, FCAMInput input, FCAMContentsManager manager){
#if DEBUG
			if(FCAMDebug.IsDebug){
				Base.Text = "Option";
			}
#endif
			menus = new List<string>(new string[]{
				"Difficult {0}",
#if CHANGE_VOLUME
				"SE (Not Implemented){0}",
				"BGM (Not Implemented){0}",
#endif
				"Key Setting{0}",
#if RANKING
				"Ranking{0}",
#endif
				"Back{0}",
			});
			menuValues = new List<string>(new string[]{
				"",
#if CHANGE_VOLUME
				"",
				"",
#endif
				"",
#if RANKING
				"",
#endif
				"",
			});
			frame = cursor = 0;
#if RANKING
	#if CHANGE_VOLUME
			menuWindowRectangle.SetLTRB(160, 200, 480, 380);
	#else
	#endif
#else
	#if CHANGE_VOLUME
			menuWindowRectangle.SetLTRB(160, 215, 480, 365);
	#else
			menuWindowRectangle.SetLTRB(160, 245, 480, 335);
	#endif
#endif
			textureBG = manager.MakeTexture(BG_FILEPATH);
			Common.ChangeBGM(BGM.Option);
		}
		protected override void Unload() {
			FCAMSystem.DisposeClass(out textureBG);
		}
		protected override void Calc(FCAMInput input, FCAMContentsManager manager){
#if DEBUG
			if(FCAMDebug.IsDebug){
				if(Common.KeyDebug1){
					frame = FRAME_MENU;
				}
			}
#endif
			menuValues[0] = " " + Game.MemoryData.GetDifficultName();
#if CHANGE_VOLUME
			menuValues[1] = " " + Game.MemoryData.SEVolume;
			menuValues[2] = " " + Game.MemoryData.BGMVolume;
#endif
			if(frame < FRAME_MENU){
				frame++;
			}else{
				Common.ReadyPlayCueSelect(cursor);
				if(Common.CommonKeyUp()){
					cursor--;
				}
				if(Common.CommonKeyDown()){
					cursor++;
				}
				if(Common.CommonKeyB()){
					Common.CueCancel.Play();
					cursor = menus.Count - 1;
				}
				cursor = FCAMMath.Mod(cursor, menus.Count);
				Common.PlayCueSelect(cursor);
				switch(cursor){
					case (sbyte)Menu.Difficult:
						Common.ReadyPlayCueSelect(Game.MemoryData.Difficult);
						if(Common.CommonKeyLeft() && Game.MemoryData.Difficult > 0){
							Game.MemoryData.Difficult--;
						}
						if(Common.CommonKeyRight() && Game.MemoryData.Difficult < Memory.MAX_DIFFICULT){
							//	条件を満たしていたら、難易度変更
							if(Game.MemoryData.Difficult < Memory.DIFFICULT_CONDITION_BORDER
							|| Game.MemoryData.ClearedStagesArray[Game.MemoryData.Difficult] >= Memory.DIFFICULT_CONDITION_CLEARED_STAGES){
								Game.MemoryData.Difficult++;
							}
						}
						Common.PlayCueSelect(Game.MemoryData.Difficult);
						break;
#if CHANGE_VOLUME
					case (sbyte)Menu.SE:
						Common.ReadyPlayCueSelect(Game.MemoryData.SEVolume);
						if(Common.CommonKeyLeft()){
							Game.MemoryData.SEVolume--;
						}
						if(Common.CommonKeyRight()){
							Game.MemoryData.SEVolume++;
						}
						Game.MemoryData.SEVolume = FCAMMath.Within((sbyte)0, Game.MemoryData.SEVolume, Memory.MAX_SEVOLUME);
						Common.PlayCueSelect(Game.MemoryData.SEVolume);
						break;
					case (sbyte)Menu.BGM:
						Common.ReadyPlayCueSelect(Game.MemoryData.BGMVolume);
						if(Common.CommonKeyLeft()){
							Common.CueSelect.Play();
							Game.MemoryData.BGMVolume--;
						}
						if(Common.CommonKeyRight()){
							Common.CueSelect.Play();
							Game.MemoryData.BGMVolume++;
						}
						Game.MemoryData.BGMVolume = FCAMMath.Within((sbyte)0, Game.MemoryData.BGMVolume, Memory.MAX_BGMVOLUME);
						Common.PlayCueSelect(Game.MemoryData.BGMVolume);
						break;
#endif
					case (sbyte)Menu.KeySetting:
						if(Common.CommonKeyA()){
							Common.CueDecide.Play();
							PushScene<KeySetting>();
						}
						break;
#if RANKING
					case (sbyte)Menu.Ranking:
					    if(Common.CommonKeyA()){
					        Common.CueDecide.Play();
					        PushScene<Ranking>();
					    }
					    break;
#endif
					case (sbyte)Menu.Back:
						if(Common.CommonKeyA()){
							Common.CueDecide.Play();
							PopScene();
						}
						break;
				}
			}

		}
		protected override void Draw(FCAMGraphics g){
			g.Font = Common.FontCommon;
			//g.FillRectangle(new FCAMColor(FCAMColor.HalfValue, FCAMColor.MinValue));
			g.FillRectangle(new FCAMColor(FCAMColor.MaxValue, FCAMColor.MinValue));
			g.DrawTexture(textureBG);
			if(frame >= FRAME_MENU){
				Common.DrawWindow(menuWindowRectangle);
				for(int i = 0; i < menus.Count; i++){
					string sz = FCAMStrings.Format(cursor == i ? ">>" + menus[i] + "<<" : menus[i], menuValues[i]);
					FCAMRectangle rectangle = g.Font.Measure(sz);
					rectangle.HorizontalCenterInto(g.Width);
					rectangle.Offset(0, i * 32 + menuWindowRectangle.Y + Common.WindowBorderWeight);
					g.DrawString(g.Font.Color.InvertRGB(), rectangle, sz);
					rectangle.Offset(-1, -1);
					g.DrawString(rectangle, sz);
				}
			}
		}
	}
}
