﻿using System.Collections.Generic;
using FukuracamDX;

namespace FatopTheWorld.Scenes{
	/// <summary>
	/// デバッグキー	フレームのスキップ。
	///					[ステージセレクト]強制ステージセレクト＆クリアステージ数更新
	/// </summary>
	class Title: FCAMScene{
		/// <summary>[difficult, Common.Stage]</summary>
		public static string[,] STAGETITLE_NAME = {
#if TRIAL
			{
				"Opening",
				"Stage 1: Burnat",
				"Stage 2: Fluip",
				"Stage 3: Scappion",
				"Ending",
			},
			{
				"Opening",
				"Stage 1: Burnat",
				"Stage 2: Fluip",
				"Stage 3: Scappion",
				"Ending",
			},
#else
			{
				"Opening",
				"Stage 1: Burnat",
				"Stage 2: Fluip",
				"Stage 3: Scappion",
				"Stage 4: Smow",
				"Final Stage: Hydead",
				"Ending(NON-TRUTH)",
				null,
				null,
				null,
				null,
				null,
				null,
			},
			{
				"Opening",
				"Stage 1: Burnat",
				"Stage 2: Fluip",
				"Stage 3: Scappion",
				"Stage 4: Smow",
				"Stage 5: Hydead",
				"Stage 6: Remilsteid",
				"Stage 7: Shadows",
				"Final Stage: Remilsteid(Rage)",
				"Ending",
				null,
				null,
				null,
			},
			{
				"Opening",
				"Stage 1: Burnat",
				"Stage 2: Fluip",
				"Stage 3: Scappion",
				"Stage 4: Smow",
				"Stage 5: Hydead",
				"Stage 6: Remilsteid",
				"Stage 7: Shadows",
				"Final Stage: Remilsteid(Rage)",
				"Ending(AND TO NEXT STAGE)",
				"Secret Stage 1",
				"Secret Stage 2",
				"Final Secret Stage: Inif",
			},
			{
				"Secret Stage 1",
				"Secret Stage 2",
				"Final Secret Stage: Inif",
				null,
				null,
				null,
				null,
				null,
				null,
				null,
				null,
				null,
				null,
			},
#endif
		};
		internal const string FILENAME_TITLE = "title.png";
		const int FRAME_MENU = 150;
		FCAMTexture textureTitle;
		List<string> menus;
		int frame, cursor;
		FCAMRectangle menuWindowRectangle;
		protected override void Load(FCAMGraphics g, FCAMInput input, FCAMContentsManager manager){
#if DEBUG
			if(FCAMDebug.IsDebug){
				Base.Text = "Title";
			}
#endif
			menus = new List<string>(new string[]{"Story Mode", "Battle Mode", "Gallery", "Config", "End Game"});
			textureTitle = manager.MakeTexture(FILENAME_TITLE);
			frame = cursor = 0;
			menuWindowRectangle.SetLTRB(160, 200, 480, 410);
			Active(null, manager);
		}
		protected override void Unload(){
			FCAMSystem.DisposeClass(out textureTitle);
		}
		protected override void Active(FCAMScene popedScene, FCAMContentsManager manager){
			//	タイトル画面でデータを保存する。
			FCAMFile.Write(Memory.FILEPATH_MEMORY, Game.MemoryData);
			if(popedScene is Battle || popedScene is Story || popedScene is Gallery){
				frame = 0;
			}
			Common.ChangeBGM(BGM.Title);
		}
		protected override void Leave(FCAMScene pushedScene){
			base.Leave(pushedScene);
		}
		protected override void Calc(FCAMInput input, FCAMContentsManager manager){
			if(frame < FRAME_MENU){
				frame++;
#if DEBUG
				if(FCAMDebug.IsDebug && Common.KeyDebug2){
					frame = FRAME_MENU;
				}
#endif
			}else{
				FCAMInputState state = Common.CommonKeyA();
				if(state){
					switch(cursor){
						case 0:
							Common.CueDecide.Play();
							PushScene<Scenes.Story>();
							//	Story を Load 時、ファイルがなければ直接エンディングシーンに入れ替わるので、
							//	ここで一旦処理が必要。
							if(this.Next is Scenes.Story){
								(this.Next as Scenes.Story).PlayerID = Common.CommonKeyPlayerID(state);
							}
							break;
						case 1:
							Common.CueDecide.Play();
							Common.Battle.Mode = Battle.BattleMode.VS;
							PushScene(Common.Battle);
							break;
						/*case 2:
							if(Common.KeyAAA){
								Common.Battle.Mode = Battle.BattleMode.Free1P;
							}else{
								Common.Battle.Mode = Battle.BattleMode.Free2P;
							}
							PushScene(Common.Battle);
							break;*/
						case 2:
							Common.CueDecide.Play();
							PushScene<Scenes.Gallery>();
							break;
						/*case 3:
							//PushScene<Scenes.Record>();
							break;*/
						case 3:
							Common.CueDecide.Play();
							PushScene<Scenes.Option>();
							break;
						case 4:
							Base.Exit();
							break;
					}
				}else{
					Common.ReadyPlayCueSelect(cursor);
					if(Common.CommonKeyUp()){
						cursor--;
					}
					if(Common.CommonKeyDown()){
						cursor++;
					}
					if(Common.CommonKeyB()){
						Common.CueCancel.Play();
						cursor = menus.Count - 1;
					}
					cursor = FCAMMath.Mod(cursor, menus.Count);
					Common.PlayCueSelect(cursor);
					switch(cursor){
						case 0:{
							Common.ReadyPlayCueSelect(Common.Stage);
							if(Common.CommonKeyLeft().Accel && Common.Stage > 0){
								Common.Stage--;
							}
#if DEBUG
							if(FCAMDebug.IsDebug && Common.KeyDebug2.Press){
								//	デバッグキー押下時は、クリアステージ数も含めて強制的にステージ選択。
								if(Common.CommonKeyRight().Accel && Common.Stage < Common.MaxStage){
									Common.Stage++;
									Game.MemoryData.ClearedStages = Common.Stage;
								}
								if(Common.CommonKeyLeft()){
									Game.MemoryData.ClearedStages = Common.Stage;
								}
							}
#endif
							//	Mod を使わないで Stage++ を安全圏内に収めているのは
							//	Stage プロパティを設定すると、自動的に CleaeredStages 内のデータも更新されてしまうため。
							if(Common.CommonKeyRight() && Common.Stage < Game.MemoryData.ClearedStages){
								Common.Stage++;
							}
							Common.PlayCueSelect(Common.Stage);
							break;
						}
					}
				}
			}
		}
		protected override void Draw(FCAMGraphics g){
			g.Font = Common.FontCommon;
			g.DrawTexture(textureTitle, new FCAMColor(FCAMMath.Min(frame * 2, FCAMColor.MaxValue), FCAMColor.MaxValue));
			if(frame >= FRAME_MENU){
				Common.DrawWindow(menuWindowRectangle);
				for(int i = 0; i < menus.Count; i++){
					string sz = cursor == i ? ">>" + menus[i] + "<<" : menus[i];
					if(i == 0){
						sz += FCAMSystem.NewLine + STAGETITLE_NAME[Game.MemoryData.Difficult, Common.Stage];
					}
					FCAMRectangle rectangle = g.Font.Measure(sz);
					rectangle.HorizontalCenterInto(g.Width);
					rectangle.Offset(0, i * 48 + menuWindowRectangle.Y + Common.WindowBorderWeight);
					g.DrawString(FCAMDrawStringFormat.Center, g.Font.Color.InvertRGB(), rectangle, sz);
					rectangle.Offset(-1, -1);
					g.DrawString(FCAMDrawStringFormat.Center, rectangle, sz);
				}
			}
		}
	}
}
